#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 11
#define STATE_COUNT 157
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 76
#define ALIAS_COUNT 0
#define TOKEN_COUNT 43
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 7

enum {
  sym_identifier = 1,
  anon_sym_COLON = 2,
  anon_sym_EQ = 3,
  anon_sym_LBRACK = 4,
  anon_sym_RBRACK = 5,
  anon_sym_LPAREN = 6,
  anon_sym_COMMA = 7,
  anon_sym_RPAREN = 8,
  anon_sym_LBRACE = 9,
  anon_sym_RBRACE = 10,
  anon_sym_TILDE = 11,
  sym_numeric = 12,
  anon_sym_true = 13,
  anon_sym_false = 14,
  sym_char = 15,
  sym_string = 16,
  anon_sym_of = 17,
  anon_sym_if = 18,
  anon_sym_then = 19,
  anon_sym_else = 20,
  anon_sym_LT_DASH = 21,
  anon_sym_let = 22,
  anon_sym_in = 23,
  anon_sym_BANG = 24,
  anon_sym_DASH = 25,
  anon_sym_EQ_EQ = 26,
  anon_sym_BANG_EQ = 27,
  anon_sym_GT = 28,
  anon_sym_GT_EQ = 29,
  anon_sym_LT = 30,
  anon_sym_LT_EQ = 31,
  anon_sym_AMP = 32,
  anon_sym_PIPE = 33,
  anon_sym_CARET = 34,
  anon_sym_BANG_CARET = 35,
  anon_sym_PLUS = 36,
  anon_sym_PERCENT = 37,
  anon_sym_STAR = 38,
  anon_sym_SLASH = 39,
  sym_exp = 40,
  anon_sym_POUND = 41,
  aux_sym_comment_token1 = 42,
  sym_source_file = 43,
  sym_definition = 44,
  sym_base_type = 45,
  sym_list_type = 46,
  sym_tuple_type = 47,
  sym_generics = 48,
  sym_general_type = 49,
  sym_named_arguments = 50,
  sym_named_argument = 51,
  sym_expression = 52,
  sym_simple = 53,
  sym_bool = 54,
  sym_list = 55,
  sym_empty_list = 56,
  sym_full_list = 57,
  sym_tuple = 58,
  sym_if = 59,
  sym_list_unpack = 60,
  sym_let = 61,
  sym_tuple_of_identifiers = 62,
  sym_prefix = 63,
  sym_call = 64,
  sym_generic_resolution = 65,
  sym_comparator = 66,
  sym_logical = 67,
  sym_add_sub = 68,
  sym_mult_div = 69,
  sym_comment = 70,
  aux_sym_source_file_repeat1 = 71,
  aux_sym_tuple_type_repeat1 = 72,
  aux_sym_generics_repeat1 = 73,
  aux_sym_named_arguments_repeat1 = 74,
  aux_sym_full_list_repeat1 = 75,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_COLON] = ":",
  [anon_sym_EQ] = "=",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LPAREN] = "(",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_TILDE] = "~",
  [sym_numeric] = "numeric",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [sym_char] = "char",
  [sym_string] = "string",
  [anon_sym_of] = "of",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_else] = "else",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_let] = "let",
  [anon_sym_in] = "in",
  [anon_sym_BANG] = "!",
  [anon_sym_DASH] = "-",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_AMP] = "&",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_BANG_CARET] = "!^",
  [anon_sym_PLUS] = "+",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [sym_exp] = "exp",
  [anon_sym_POUND] = "#",
  [aux_sym_comment_token1] = "comment_token1",
  [sym_source_file] = "source_file",
  [sym_definition] = "definition",
  [sym_base_type] = "base_type",
  [sym_list_type] = "list_type",
  [sym_tuple_type] = "tuple_type",
  [sym_generics] = "generics",
  [sym_general_type] = "general_type",
  [sym_named_arguments] = "named_arguments",
  [sym_named_argument] = "named_argument",
  [sym_expression] = "expression",
  [sym_simple] = "simple",
  [sym_bool] = "bool",
  [sym_list] = "list",
  [sym_empty_list] = "empty_list",
  [sym_full_list] = "full_list",
  [sym_tuple] = "tuple",
  [sym_if] = "if",
  [sym_list_unpack] = "list_unpack",
  [sym_let] = "let",
  [sym_tuple_of_identifiers] = "tuple_of_identifiers",
  [sym_prefix] = "prefix",
  [sym_call] = "call",
  [sym_generic_resolution] = "generic_resolution",
  [sym_comparator] = "comparator",
  [sym_logical] = "logical",
  [sym_add_sub] = "add_sub",
  [sym_mult_div] = "mult_div",
  [sym_comment] = "comment",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [aux_sym_generics_repeat1] = "generics_repeat1",
  [aux_sym_named_arguments_repeat1] = "named_arguments_repeat1",
  [aux_sym_full_list_repeat1] = "full_list_repeat1",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [sym_numeric] = sym_numeric,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [sym_char] = sym_char,
  [sym_string] = sym_string,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_BANG_CARET] = anon_sym_BANG_CARET,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [sym_exp] = sym_exp,
  [anon_sym_POUND] = anon_sym_POUND,
  [aux_sym_comment_token1] = aux_sym_comment_token1,
  [sym_source_file] = sym_source_file,
  [sym_definition] = sym_definition,
  [sym_base_type] = sym_base_type,
  [sym_list_type] = sym_list_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_generics] = sym_generics,
  [sym_general_type] = sym_general_type,
  [sym_named_arguments] = sym_named_arguments,
  [sym_named_argument] = sym_named_argument,
  [sym_expression] = sym_expression,
  [sym_simple] = sym_simple,
  [sym_bool] = sym_bool,
  [sym_list] = sym_list,
  [sym_empty_list] = sym_empty_list,
  [sym_full_list] = sym_full_list,
  [sym_tuple] = sym_tuple,
  [sym_if] = sym_if,
  [sym_list_unpack] = sym_list_unpack,
  [sym_let] = sym_let,
  [sym_tuple_of_identifiers] = sym_tuple_of_identifiers,
  [sym_prefix] = sym_prefix,
  [sym_call] = sym_call,
  [sym_generic_resolution] = sym_generic_resolution,
  [sym_comparator] = sym_comparator,
  [sym_logical] = sym_logical,
  [sym_add_sub] = sym_add_sub,
  [sym_mult_div] = sym_mult_div,
  [sym_comment] = sym_comment,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [aux_sym_generics_repeat1] = aux_sym_generics_repeat1,
  [aux_sym_named_arguments_repeat1] = aux_sym_named_arguments_repeat1,
  [aux_sym_full_list_repeat1] = aux_sym_full_list_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [sym_numeric] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [sym_char] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [sym_exp] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_comment_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_base_type] = {
    .visible = true,
    .named = true,
  },
  [sym_list_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generics] = {
    .visible = true,
    .named = true,
  },
  [sym_general_type] = {
    .visible = true,
    .named = true,
  },
  [sym_named_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_named_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_simple] = {
    .visible = true,
    .named = true,
  },
  [sym_bool] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_list] = {
    .visible = true,
    .named = true,
  },
  [sym_full_list] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_if] = {
    .visible = true,
    .named = true,
  },
  [sym_list_unpack] = {
    .visible = true,
    .named = true,
  },
  [sym_let] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_of_identifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_resolution] = {
    .visible = true,
    .named = true,
  },
  [sym_comparator] = {
    .visible = true,
    .named = true,
  },
  [sym_logical] = {
    .visible = true,
    .named = true,
  },
  [sym_add_sub] = {
    .visible = true,
    .named = true,
  },
  [sym_mult_div] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_generics_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_full_list_repeat1] = {
    .visible = false,
    .named = false,
  },
};

static TSSymbol ts_alias_sequences[1][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(12);
      if (lookahead == '!') ADVANCE(31);
      if (lookahead == '"') ADVANCE(2);
      if (lookahead == '#') ADVANCE(49);
      if (lookahead == '%') ADVANCE(45);
      if (lookahead == '&') ADVANCE(40);
      if (lookahead == '\'') ADVANCE(7);
      if (lookahead == '(') ADVANCE(18);
      if (lookahead == ')') ADVANCE(20);
      if (lookahead == '*') ADVANCE(46);
      if (lookahead == '+') ADVANCE(44);
      if (lookahead == ',') ADVANCE(19);
      if (lookahead == '-') ADVANCE(33);
      if (lookahead == '/') ADVANCE(47);
      if (lookahead == '0') ADVANCE(25);
      if (lookahead == ':') ADVANCE(13);
      if (lookahead == '<') ADVANCE(38);
      if (lookahead == '=') ADVANCE(15);
      if (lookahead == '>') ADVANCE(36);
      if (lookahead == '[') ADVANCE(16);
      if (lookahead == ']') ADVANCE(17);
      if (lookahead == '^') ADVANCE(42);
      if (lookahead == '{') ADVANCE(21);
      if (lookahead == '|') ADVANCE(41);
      if (lookahead == '}') ADVANCE(22);
      if (lookahead == '~') ADVANCE(23);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(26);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(24);
      END_STATE();
    case 1:
      if (lookahead == '!') ADVANCE(30);
      if (lookahead == '"') ADVANCE(2);
      if (lookahead == '#') ADVANCE(49);
      if (lookahead == '\'') ADVANCE(7);
      if (lookahead == '(') ADVANCE(18);
      if (lookahead == ')') ADVANCE(20);
      if (lookahead == '-') ADVANCE(33);
      if (lookahead == '0') ADVANCE(25);
      if (lookahead == ':') ADVANCE(13);
      if (lookahead == '<') ADVANCE(4);
      if (lookahead == '=') ADVANCE(14);
      if (lookahead == '[') ADVANCE(16);
      if (lookahead == ']') ADVANCE(17);
      if (lookahead == '{') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(26);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(24);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(8);
      if (lookahead == '\t' ||
          (' ' <= lookahead && lookahead <= '~')) ADVANCE(2);
      END_STATE();
    case 3:
      if (lookahead == '\'') ADVANCE(27);
      END_STATE();
    case 4:
      if (lookahead == '-') ADVANCE(29);
      END_STATE();
    case 5:
      if (lookahead == '=') ADVANCE(35);
      if (lookahead == '^') ADVANCE(43);
      END_STATE();
    case 6:
      if (lookahead == '=') ADVANCE(34);
      END_STATE();
    case 7:
      if (lookahead == '\\') ADVANCE(9);
      if (lookahead == '\t' ||
          lookahead == ' ' ||
          lookahead == '!' ||
          ('#' <= lookahead && lookahead <= '~')) ADVANCE(3);
      END_STATE();
    case 8:
      if (lookahead == '"' ||
          lookahead == '\\' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          lookahead == 't') ADVANCE(2);
      END_STATE();
    case 9:
      if (lookahead == '"' ||
          lookahead == '\\' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          lookahead == 't') ADVANCE(3);
      END_STATE();
    case 10:
      if (eof) ADVANCE(12);
      if (lookahead == '!') ADVANCE(5);
      if (lookahead == '#') ADVANCE(49);
      if (lookahead == '%') ADVANCE(45);
      if (lookahead == '&') ADVANCE(40);
      if (lookahead == '(') ADVANCE(18);
      if (lookahead == ')') ADVANCE(20);
      if (lookahead == '*') ADVANCE(46);
      if (lookahead == '+') ADVANCE(44);
      if (lookahead == ',') ADVANCE(19);
      if (lookahead == '-') ADVANCE(32);
      if (lookahead == '/') ADVANCE(47);
      if (lookahead == '<') ADVANCE(38);
      if (lookahead == '=') ADVANCE(15);
      if (lookahead == '>') ADVANCE(36);
      if (lookahead == ']') ADVANCE(17);
      if (lookahead == '^') ADVANCE(42);
      if (lookahead == '|') ADVANCE(41);
      if (lookahead == '}') ADVANCE(22);
      if (lookahead == '~') ADVANCE(23);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(10)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(24);
      END_STATE();
    case 11:
      if (eof) ADVANCE(12);
      if (lookahead == '!') ADVANCE(5);
      if (lookahead == '#') ADVANCE(49);
      if (lookahead == '%') ADVANCE(45);
      if (lookahead == '&') ADVANCE(40);
      if (lookahead == '(') ADVANCE(18);
      if (lookahead == ')') ADVANCE(20);
      if (lookahead == '*') ADVANCE(46);
      if (lookahead == '+') ADVANCE(44);
      if (lookahead == ',') ADVANCE(19);
      if (lookahead == '-') ADVANCE(32);
      if (lookahead == '/') ADVANCE(47);
      if (lookahead == '<') ADVANCE(38);
      if (lookahead == '=') ADVANCE(6);
      if (lookahead == '>') ADVANCE(36);
      if (lookahead == ']') ADVANCE(17);
      if (lookahead == '^') ADVANCE(42);
      if (lookahead == '{') ADVANCE(21);
      if (lookahead == '|') ADVANCE(41);
      if (lookahead == '}') ADVANCE(22);
      if (lookahead == '~') ADVANCE(23);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(11)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(24);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(34);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(24);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(sym_numeric);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(sym_numeric);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(26);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(sym_char);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(sym_string);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(35);
      if (lookahead == '^') ADVANCE(43);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '0') ADVANCE(25);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(26);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(37);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(39);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_BANG_CARET);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(48);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(sym_exp);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(50);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(51);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(51);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'e') ADVANCE(1);
      if (lookahead == 'f') ADVANCE(2);
      if (lookahead == 'i') ADVANCE(3);
      if (lookahead == 'l') ADVANCE(4);
      if (lookahead == 'o') ADVANCE(5);
      if (lookahead == 't') ADVANCE(6);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'l') ADVANCE(7);
      END_STATE();
    case 2:
      if (lookahead == 'a') ADVANCE(8);
      END_STATE();
    case 3:
      if (lookahead == 'f') ADVANCE(9);
      if (lookahead == 'n') ADVANCE(10);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(11);
      END_STATE();
    case 5:
      if (lookahead == 'f') ADVANCE(12);
      END_STATE();
    case 6:
      if (lookahead == 'h') ADVANCE(13);
      if (lookahead == 'r') ADVANCE(14);
      END_STATE();
    case 7:
      if (lookahead == 's') ADVANCE(15);
      END_STATE();
    case 8:
      if (lookahead == 'l') ADVANCE(16);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 11:
      if (lookahead == 't') ADVANCE(17);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(18);
      END_STATE();
    case 14:
      if (lookahead == 'u') ADVANCE(19);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(20);
      END_STATE();
    case 16:
      if (lookahead == 's') ADVANCE(21);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 18:
      if (lookahead == 'n') ADVANCE(22);
      END_STATE();
    case 19:
      if (lookahead == 'e') ADVANCE(23);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 21:
      if (lookahead == 'e') ADVANCE(24);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 0},
  [2] = {.lex_state = 11},
  [3] = {.lex_state = 11},
  [4] = {.lex_state = 11},
  [5] = {.lex_state = 11},
  [6] = {.lex_state = 11},
  [7] = {.lex_state = 11},
  [8] = {.lex_state = 11},
  [9] = {.lex_state = 10},
  [10] = {.lex_state = 10},
  [11] = {.lex_state = 10},
  [12] = {.lex_state = 10},
  [13] = {.lex_state = 10},
  [14] = {.lex_state = 10},
  [15] = {.lex_state = 11},
  [16] = {.lex_state = 11},
  [17] = {.lex_state = 11},
  [18] = {.lex_state = 11},
  [19] = {.lex_state = 11},
  [20] = {.lex_state = 11},
  [21] = {.lex_state = 11},
  [22] = {.lex_state = 11},
  [23] = {.lex_state = 11},
  [24] = {.lex_state = 11},
  [25] = {.lex_state = 11},
  [26] = {.lex_state = 11},
  [27] = {.lex_state = 11},
  [28] = {.lex_state = 11},
  [29] = {.lex_state = 11},
  [30] = {.lex_state = 11},
  [31] = {.lex_state = 11},
  [32] = {.lex_state = 11},
  [33] = {.lex_state = 11},
  [34] = {.lex_state = 11},
  [35] = {.lex_state = 11},
  [36] = {.lex_state = 11},
  [37] = {.lex_state = 1},
  [38] = {.lex_state = 1},
  [39] = {.lex_state = 1},
  [40] = {.lex_state = 11},
  [41] = {.lex_state = 11},
  [42] = {.lex_state = 11},
  [43] = {.lex_state = 11},
  [44] = {.lex_state = 1},
  [45] = {.lex_state = 1},
  [46] = {.lex_state = 1},
  [47] = {.lex_state = 1},
  [48] = {.lex_state = 1},
  [49] = {.lex_state = 11},
  [50] = {.lex_state = 1},
  [51] = {.lex_state = 1},
  [52] = {.lex_state = 1},
  [53] = {.lex_state = 1},
  [54] = {.lex_state = 11},
  [55] = {.lex_state = 1},
  [56] = {.lex_state = 11},
  [57] = {.lex_state = 11},
  [58] = {.lex_state = 1},
  [59] = {.lex_state = 11},
  [60] = {.lex_state = 1},
  [61] = {.lex_state = 1},
  [62] = {.lex_state = 1},
  [63] = {.lex_state = 1},
  [64] = {.lex_state = 1},
  [65] = {.lex_state = 1},
  [66] = {.lex_state = 1},
  [67] = {.lex_state = 1},
  [68] = {.lex_state = 1},
  [69] = {.lex_state = 11},
  [70] = {.lex_state = 1},
  [71] = {.lex_state = 1},
  [72] = {.lex_state = 11},
  [73] = {.lex_state = 11},
  [74] = {.lex_state = 1},
  [75] = {.lex_state = 1},
  [76] = {.lex_state = 1},
  [77] = {.lex_state = 1},
  [78] = {.lex_state = 0},
  [79] = {.lex_state = 0},
  [80] = {.lex_state = 0},
  [81] = {.lex_state = 0},
  [82] = {.lex_state = 0},
  [83] = {.lex_state = 0},
  [84] = {.lex_state = 0},
  [85] = {.lex_state = 0},
  [86] = {.lex_state = 0},
  [87] = {.lex_state = 0},
  [88] = {.lex_state = 1},
  [89] = {.lex_state = 0},
  [90] = {.lex_state = 0},
  [91] = {.lex_state = 0},
  [92] = {.lex_state = 1},
  [93] = {.lex_state = 0},
  [94] = {.lex_state = 0},
  [95] = {.lex_state = 0},
  [96] = {.lex_state = 0},
  [97] = {.lex_state = 0},
  [98] = {.lex_state = 0},
  [99] = {.lex_state = 0},
  [100] = {.lex_state = 0},
  [101] = {.lex_state = 0},
  [102] = {.lex_state = 1},
  [103] = {.lex_state = 0},
  [104] = {.lex_state = 0},
  [105] = {.lex_state = 0},
  [106] = {.lex_state = 1},
  [107] = {.lex_state = 0},
  [108] = {.lex_state = 0},
  [109] = {.lex_state = 1},
  [110] = {.lex_state = 0},
  [111] = {.lex_state = 0},
  [112] = {.lex_state = 0},
  [113] = {.lex_state = 1},
  [114] = {.lex_state = 0},
  [115] = {.lex_state = 0},
  [116] = {.lex_state = 0},
  [117] = {.lex_state = 1},
  [118] = {.lex_state = 0},
  [119] = {.lex_state = 0},
  [120] = {.lex_state = 0},
  [121] = {.lex_state = 0},
  [122] = {.lex_state = 0},
  [123] = {.lex_state = 0},
  [124] = {.lex_state = 0},
  [125] = {.lex_state = 0},
  [126] = {.lex_state = 0},
  [127] = {.lex_state = 0},
  [128] = {.lex_state = 0},
  [129] = {.lex_state = 0},
  [130] = {.lex_state = 1},
  [131] = {.lex_state = 1},
  [132] = {.lex_state = 0},
  [133] = {.lex_state = 0},
  [134] = {.lex_state = 0},
  [135] = {.lex_state = 0},
  [136] = {.lex_state = 0},
  [137] = {.lex_state = 1},
  [138] = {.lex_state = 0},
  [139] = {.lex_state = 1},
  [140] = {.lex_state = 1},
  [141] = {.lex_state = 0},
  [142] = {.lex_state = 1},
  [143] = {.lex_state = 0},
  [144] = {.lex_state = 1},
  [145] = {.lex_state = 1},
  [146] = {.lex_state = 1},
  [147] = {.lex_state = 0},
  [148] = {.lex_state = 1},
  [149] = {.lex_state = 1},
  [150] = {.lex_state = 1},
  [151] = {.lex_state = 1},
  [152] = {.lex_state = 1},
  [153] = {.lex_state = 0},
  [154] = {.lex_state = 0},
  [155] = {(TSStateId)(-1)},
  [156] = {.lex_state = 50},
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_comment] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [sym_numeric] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [sym_char] = ACTIONS(1),
    [sym_string] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_BANG_CARET] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [sym_exp] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(3),
  },
  [1] = {
    [sym_source_file] = STATE(153),
    [sym_definition] = STATE(123),
    [sym_comment] = STATE(1),
    [aux_sym_source_file_repeat1] = STATE(96),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_POUND] = ACTIONS(3),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_SLASH,
    ACTIONS(29), 1,
      sym_exp,
    STATE(2), 1,
      sym_comment,
    STATE(36), 1,
      sym_tuple,
    STATE(51), 1,
      sym_comparator,
    STATE(68), 1,
      sym_mult_div,
    ACTIONS(21), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(67), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(17), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
    ACTIONS(9), 4,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(11), 4,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
    ACTIONS(19), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(23), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [68] = 17,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_SLASH,
    ACTIONS(29), 1,
      sym_exp,
    STATE(3), 1,
      sym_comment,
    STATE(36), 1,
      sym_tuple,
    STATE(51), 1,
      sym_comparator,
    STATE(68), 1,
      sym_mult_div,
    ACTIONS(21), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(67), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(17), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
    ACTIONS(19), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(23), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
    ACTIONS(31), 4,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(33), 4,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
  [136] = 14,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_SLASH,
    ACTIONS(29), 1,
      sym_exp,
    STATE(4), 1,
      sym_comment,
    STATE(36), 1,
      sym_tuple,
    STATE(51), 1,
      sym_comparator,
    STATE(68), 1,
      sym_mult_div,
    STATE(67), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(17), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
    ACTIONS(23), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
    ACTIONS(37), 6,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(35), 9,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [198] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    STATE(5), 1,
      sym_comment,
    STATE(36), 1,
      sym_tuple,
    STATE(51), 1,
      sym_comparator,
    STATE(68), 1,
      sym_mult_div,
    STATE(67), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(37), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(35), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [250] = 12,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_SLASH,
    ACTIONS(29), 1,
      sym_exp,
    STATE(6), 1,
      sym_comment,
    STATE(36), 1,
      sym_tuple,
    STATE(51), 1,
      sym_comparator,
    STATE(68), 1,
      sym_mult_div,
    STATE(67), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(37), 6,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(35), 16,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
  [308] = 10,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(29), 1,
      sym_exp,
    STATE(7), 1,
      sym_comment,
    STATE(36), 1,
      sym_tuple,
    STATE(51), 1,
      sym_comparator,
    STATE(68), 1,
      sym_mult_div,
    STATE(67), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(37), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(35), 17,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
  [362] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    STATE(8), 1,
      sym_comment,
    STATE(36), 1,
      sym_tuple,
    STATE(51), 1,
      sym_comparator,
    STATE(68), 1,
      sym_mult_div,
    STATE(67), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(41), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(39), 18,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [414] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(9), 1,
      sym_comment,
    ACTIONS(45), 8,
      anon_sym_EQ,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(43), 20,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [453] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(10), 1,
      sym_comment,
    ACTIONS(49), 8,
      anon_sym_EQ,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(47), 20,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [492] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(11), 1,
      sym_comment,
    ACTIONS(53), 8,
      anon_sym_EQ,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(51), 20,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [531] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(12), 1,
      sym_comment,
    ACTIONS(57), 8,
      anon_sym_EQ,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(55), 20,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [570] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(13), 1,
      sym_comment,
    ACTIONS(61), 8,
      anon_sym_EQ,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(59), 20,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [609] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(14), 1,
      sym_comment,
    ACTIONS(65), 8,
      anon_sym_EQ,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(63), 20,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [648] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(15), 1,
      sym_comment,
    ACTIONS(69), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(67), 20,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [686] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(15), 1,
      sym_tuple_type,
    STATE(16), 1,
      sym_comment,
    ACTIONS(73), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(71), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [726] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(79), 1,
      anon_sym_LBRACE,
    STATE(17), 1,
      sym_comment,
    ACTIONS(77), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(75), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [766] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(18), 1,
      sym_comment,
    ACTIONS(83), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(81), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [803] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(19), 1,
      sym_comment,
    ACTIONS(87), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(85), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [840] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_SLASH,
    ACTIONS(29), 1,
      sym_exp,
    ACTIONS(89), 1,
      anon_sym_RBRACK,
    ACTIONS(91), 1,
      anon_sym_COMMA,
    STATE(20), 1,
      sym_comment,
    STATE(36), 1,
      sym_tuple,
    STATE(51), 1,
      sym_comparator,
    STATE(68), 1,
      sym_mult_div,
    STATE(99), 1,
      aux_sym_full_list_repeat1,
    ACTIONS(21), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(67), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(17), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
    ACTIONS(19), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(23), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [905] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(21), 1,
      sym_comment,
    ACTIONS(95), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(93), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [942] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(22), 1,
      sym_comment,
    ACTIONS(77), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(75), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [979] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(23), 1,
      sym_comment,
    ACTIONS(99), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(97), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1016] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_SLASH,
    ACTIONS(29), 1,
      sym_exp,
    STATE(24), 1,
      sym_comment,
    STATE(36), 1,
      sym_tuple,
    STATE(51), 1,
      sym_comparator,
    STATE(68), 1,
      sym_mult_div,
    ACTIONS(21), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(67), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(17), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
    ACTIONS(101), 3,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(19), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(23), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [1077] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(25), 1,
      sym_comment,
    ACTIONS(105), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(103), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1114] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(26), 1,
      sym_comment,
    ACTIONS(109), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(107), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1151] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(27), 1,
      sym_comment,
    ACTIONS(113), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(111), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1188] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(28), 1,
      sym_comment,
    ACTIONS(117), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(115), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1225] = 18,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_SLASH,
    ACTIONS(29), 1,
      sym_exp,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_RPAREN,
    STATE(29), 1,
      sym_comment,
    STATE(36), 1,
      sym_tuple,
    STATE(51), 1,
      sym_comparator,
    STATE(68), 1,
      sym_mult_div,
    STATE(120), 1,
      aux_sym_full_list_repeat1,
    ACTIONS(21), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(67), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(17), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
    ACTIONS(19), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(23), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [1290] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(30), 1,
      sym_comment,
    ACTIONS(125), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(123), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1327] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(31), 1,
      sym_comment,
    ACTIONS(129), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(127), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1364] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(32), 1,
      sym_comment,
    ACTIONS(133), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(131), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1401] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(33), 1,
      sym_comment,
    ACTIONS(137), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(135), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1438] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(34), 1,
      sym_comment,
    ACTIONS(141), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(139), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1475] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(35), 1,
      sym_comment,
    ACTIONS(145), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(143), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1512] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(36), 1,
      sym_comment,
    ACTIONS(149), 7,
      sym_identifier,
      anon_sym_then,
      anon_sym_else,
      anon_sym_in,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(147), 19,
      ts_builtin_sym_end,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_TILDE,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [1549] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(151), 1,
      sym_identifier,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(155), 1,
      anon_sym_LPAREN,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    STATE(22), 1,
      sym_bool,
    STATE(37), 1,
      sym_comment,
    STATE(57), 1,
      sym_expression,
    STATE(147), 1,
      sym_list_unpack,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [1609] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    ACTIONS(169), 1,
      sym_identifier,
    ACTIONS(171), 1,
      anon_sym_RPAREN,
    STATE(22), 1,
      sym_bool,
    STATE(24), 1,
      sym_expression,
    STATE(38), 1,
      sym_comment,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [1669] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    ACTIONS(169), 1,
      sym_identifier,
    ACTIONS(173), 1,
      anon_sym_RBRACK,
    STATE(22), 1,
      sym_bool,
    STATE(24), 1,
      sym_expression,
    STATE(39), 1,
      sym_comment,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [1729] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_SLASH,
    ACTIONS(29), 1,
      sym_exp,
    STATE(36), 1,
      sym_tuple,
    STATE(40), 1,
      sym_comment,
    STATE(51), 1,
      sym_comparator,
    STATE(68), 1,
      sym_mult_div,
    ACTIONS(21), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(175), 2,
      ts_builtin_sym_end,
      sym_identifier,
    STATE(67), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(17), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
    ACTIONS(19), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(23), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [1789] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_SLASH,
    ACTIONS(29), 1,
      sym_exp,
    STATE(36), 1,
      sym_tuple,
    STATE(41), 1,
      sym_comment,
    STATE(51), 1,
      sym_comparator,
    STATE(68), 1,
      sym_mult_div,
    ACTIONS(21), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(177), 2,
      ts_builtin_sym_end,
      sym_identifier,
    STATE(67), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(17), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
    ACTIONS(19), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(23), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [1849] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_SLASH,
    ACTIONS(29), 1,
      sym_exp,
    STATE(36), 1,
      sym_tuple,
    STATE(42), 1,
      sym_comment,
    STATE(51), 1,
      sym_comparator,
    STATE(68), 1,
      sym_mult_div,
    ACTIONS(21), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(179), 2,
      ts_builtin_sym_end,
      sym_identifier,
    STATE(67), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(17), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
    ACTIONS(19), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(23), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [1909] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_SLASH,
    ACTIONS(29), 1,
      sym_exp,
    STATE(36), 1,
      sym_tuple,
    STATE(43), 1,
      sym_comment,
    STATE(51), 1,
      sym_comparator,
    STATE(68), 1,
      sym_mult_div,
    ACTIONS(21), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(181), 2,
      ts_builtin_sym_end,
      sym_identifier,
    STATE(67), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(17), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
    ACTIONS(19), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(23), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [1969] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    ACTIONS(169), 1,
      sym_identifier,
    ACTIONS(183), 1,
      anon_sym_RPAREN,
    STATE(22), 1,
      sym_bool,
    STATE(29), 1,
      sym_expression,
    STATE(44), 1,
      sym_comment,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [2029] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    ACTIONS(169), 1,
      sym_identifier,
    ACTIONS(185), 1,
      anon_sym_RBRACK,
    STATE(20), 1,
      sym_expression,
    STATE(22), 1,
      sym_bool,
    STATE(45), 1,
      sym_comment,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [2089] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    ACTIONS(169), 1,
      sym_identifier,
    ACTIONS(187), 1,
      anon_sym_RBRACK,
    STATE(22), 1,
      sym_bool,
    STATE(24), 1,
      sym_expression,
    STATE(46), 1,
      sym_comment,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [2149] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    ACTIONS(169), 1,
      sym_identifier,
    ACTIONS(189), 1,
      anon_sym_RPAREN,
    STATE(22), 1,
      sym_bool,
    STATE(24), 1,
      sym_expression,
    STATE(47), 1,
      sym_comment,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [2209] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    ACTIONS(183), 1,
      anon_sym_RPAREN,
    ACTIONS(191), 1,
      sym_identifier,
    STATE(22), 1,
      sym_bool,
    STATE(29), 1,
      sym_expression,
    STATE(48), 1,
      sym_comment,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [2269] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_SLASH,
    ACTIONS(29), 1,
      sym_exp,
    STATE(36), 1,
      sym_tuple,
    STATE(49), 1,
      sym_comment,
    STATE(51), 1,
      sym_comparator,
    STATE(68), 1,
      sym_mult_div,
    ACTIONS(21), 2,
      anon_sym_GT,
      anon_sym_LT,
    ACTIONS(193), 2,
      ts_builtin_sym_end,
      sym_identifier,
    STATE(67), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(17), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
    ACTIONS(19), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(23), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [2329] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    ACTIONS(169), 1,
      sym_identifier,
    STATE(22), 1,
      sym_bool,
    STATE(43), 1,
      sym_expression,
    STATE(50), 1,
      sym_comment,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [2386] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    ACTIONS(169), 1,
      sym_identifier,
    STATE(4), 1,
      sym_expression,
    STATE(22), 1,
      sym_bool,
    STATE(51), 1,
      sym_comment,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [2443] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    ACTIONS(169), 1,
      sym_identifier,
    STATE(22), 1,
      sym_bool,
    STATE(41), 1,
      sym_expression,
    STATE(52), 1,
      sym_comment,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [2500] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    ACTIONS(169), 1,
      sym_identifier,
    STATE(8), 1,
      sym_expression,
    STATE(22), 1,
      sym_bool,
    STATE(53), 1,
      sym_comment,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [2557] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_SLASH,
    ACTIONS(29), 1,
      sym_exp,
    ACTIONS(195), 1,
      anon_sym_then,
    STATE(36), 1,
      sym_tuple,
    STATE(51), 1,
      sym_comparator,
    STATE(54), 1,
      sym_comment,
    STATE(68), 1,
      sym_mult_div,
    ACTIONS(21), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(67), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(17), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
    ACTIONS(19), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(23), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [2616] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    ACTIONS(169), 1,
      sym_identifier,
    STATE(22), 1,
      sym_bool,
    STATE(55), 1,
      sym_comment,
    STATE(56), 1,
      sym_expression,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [2673] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_SLASH,
    ACTIONS(29), 1,
      sym_exp,
    ACTIONS(197), 1,
      anon_sym_in,
    STATE(36), 1,
      sym_tuple,
    STATE(51), 1,
      sym_comparator,
    STATE(56), 1,
      sym_comment,
    STATE(68), 1,
      sym_mult_div,
    ACTIONS(21), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(67), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(17), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
    ACTIONS(19), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(23), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [2732] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_SLASH,
    ACTIONS(29), 1,
      sym_exp,
    ACTIONS(199), 1,
      anon_sym_then,
    STATE(36), 1,
      sym_tuple,
    STATE(51), 1,
      sym_comparator,
    STATE(57), 1,
      sym_comment,
    STATE(68), 1,
      sym_mult_div,
    ACTIONS(21), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(67), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(17), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
    ACTIONS(19), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(23), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [2791] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    ACTIONS(169), 1,
      sym_identifier,
    STATE(22), 1,
      sym_bool,
    STATE(54), 1,
      sym_expression,
    STATE(58), 1,
      sym_comment,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [2848] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_SLASH,
    ACTIONS(29), 1,
      sym_exp,
    ACTIONS(201), 1,
      anon_sym_then,
    STATE(36), 1,
      sym_tuple,
    STATE(51), 1,
      sym_comparator,
    STATE(59), 1,
      sym_comment,
    STATE(68), 1,
      sym_mult_div,
    ACTIONS(21), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(67), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(17), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
    ACTIONS(19), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(23), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [2907] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    ACTIONS(169), 1,
      sym_identifier,
    STATE(22), 1,
      sym_bool,
    STATE(60), 1,
      sym_comment,
    STATE(69), 1,
      sym_expression,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [2964] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    ACTIONS(169), 1,
      sym_identifier,
    STATE(22), 1,
      sym_bool,
    STATE(59), 1,
      sym_expression,
    STATE(61), 1,
      sym_comment,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [3021] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    ACTIONS(169), 1,
      sym_identifier,
    STATE(22), 1,
      sym_bool,
    STATE(42), 1,
      sym_expression,
    STATE(62), 1,
      sym_comment,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [3078] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    ACTIONS(169), 1,
      sym_identifier,
    STATE(22), 1,
      sym_bool,
    STATE(24), 1,
      sym_expression,
    STATE(63), 1,
      sym_comment,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [3135] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    ACTIONS(169), 1,
      sym_identifier,
    STATE(22), 1,
      sym_bool,
    STATE(40), 1,
      sym_expression,
    STATE(64), 1,
      sym_comment,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [3192] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    ACTIONS(169), 1,
      sym_identifier,
    STATE(22), 1,
      sym_bool,
    STATE(49), 1,
      sym_expression,
    STATE(65), 1,
      sym_comment,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [3249] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    ACTIONS(169), 1,
      sym_identifier,
    STATE(5), 1,
      sym_expression,
    STATE(22), 1,
      sym_bool,
    STATE(66), 1,
      sym_comment,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [3306] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    ACTIONS(169), 1,
      sym_identifier,
    STATE(6), 1,
      sym_expression,
    STATE(22), 1,
      sym_bool,
    STATE(67), 1,
      sym_comment,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [3363] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    ACTIONS(169), 1,
      sym_identifier,
    STATE(7), 1,
      sym_expression,
    STATE(22), 1,
      sym_bool,
    STATE(68), 1,
      sym_comment,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [3420] = 16,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(15), 1,
      anon_sym_TILDE,
    ACTIONS(25), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_SLASH,
    ACTIONS(29), 1,
      sym_exp,
    ACTIONS(203), 1,
      anon_sym_else,
    STATE(36), 1,
      sym_tuple,
    STATE(51), 1,
      sym_comparator,
    STATE(68), 1,
      sym_mult_div,
    STATE(69), 1,
      sym_comment,
    ACTIONS(21), 2,
      anon_sym_GT,
      anon_sym_LT,
    STATE(67), 2,
      sym_logical,
      sym_add_sub,
    ACTIONS(17), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
    ACTIONS(19), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(23), 4,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
  [3479] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    ACTIONS(169), 1,
      sym_identifier,
    STATE(2), 1,
      sym_expression,
    STATE(22), 1,
      sym_bool,
    STATE(70), 1,
      sym_comment,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [3536] = 15,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(153), 1,
      anon_sym_LBRACK,
    ACTIONS(161), 1,
      anon_sym_if,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(165), 1,
      anon_sym_BANG,
    ACTIONS(167), 1,
      anon_sym_DASH,
    ACTIONS(169), 1,
      sym_identifier,
    STATE(3), 1,
      sym_expression,
    STATE(22), 1,
      sym_bool,
    STATE(71), 1,
      sym_comment,
    ACTIONS(159), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(28), 2,
      sym_empty_list,
      sym_full_list,
    ACTIONS(157), 3,
      sym_numeric,
      sym_char,
      sym_string,
    STATE(27), 8,
      sym_simple,
      sym_list,
      sym_tuple,
      sym_if,
      sym_let,
      sym_prefix,
      sym_call,
      sym_generic_resolution,
  [3593] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(79), 1,
      anon_sym_LBRACE,
    ACTIONS(205), 1,
      anon_sym_TILDE,
    STATE(72), 1,
      sym_comment,
    ACTIONS(77), 3,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(75), 16,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [3629] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(79), 1,
      anon_sym_LBRACE,
    ACTIONS(207), 1,
      anon_sym_TILDE,
    STATE(73), 1,
      sym_comment,
    ACTIONS(77), 3,
      anon_sym_GT,
      anon_sym_LT,
      anon_sym_STAR,
    ACTIONS(75), 15,
      anon_sym_LPAREN,
      anon_sym_then,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_BANG_CARET,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH,
      sym_exp,
  [3664] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(74), 1,
      sym_comment,
    ACTIONS(209), 6,
      sym_identifier,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_let,
      anon_sym_DASH,
    ACTIONS(211), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_numeric,
      sym_char,
      sym_string,
      anon_sym_BANG,
  [3687] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(75), 1,
      sym_comment,
    ACTIONS(213), 6,
      sym_identifier,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_let,
      anon_sym_DASH,
    ACTIONS(215), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_numeric,
      sym_char,
      sym_string,
      anon_sym_BANG,
  [3710] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(76), 1,
      sym_comment,
    ACTIONS(217), 6,
      sym_identifier,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_let,
      anon_sym_DASH,
    ACTIONS(219), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_numeric,
      sym_char,
      sym_string,
      anon_sym_BANG,
  [3733] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(77), 1,
      sym_comment,
    ACTIONS(221), 6,
      sym_identifier,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_let,
      anon_sym_DASH,
    ACTIONS(223), 6,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      sym_numeric,
      sym_char,
      sym_string,
      anon_sym_BANG,
  [3756] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(225), 1,
      sym_identifier,
    ACTIONS(227), 1,
      anon_sym_LBRACK,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(231), 1,
      anon_sym_RBRACE,
    STATE(78), 1,
      sym_comment,
    STATE(91), 1,
      sym_base_type,
    STATE(108), 1,
      sym_general_type,
    STATE(14), 2,
      sym_list_type,
      sym_tuple_type,
  [3785] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(225), 1,
      sym_identifier,
    ACTIONS(227), 1,
      anon_sym_LBRACK,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(233), 1,
      anon_sym_RPAREN,
    STATE(79), 1,
      sym_comment,
    STATE(91), 1,
      sym_base_type,
    STATE(108), 1,
      sym_general_type,
    STATE(14), 2,
      sym_list_type,
      sym_tuple_type,
  [3814] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(225), 1,
      sym_identifier,
    ACTIONS(227), 1,
      anon_sym_LBRACK,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(235), 1,
      anon_sym_RBRACE,
    STATE(80), 1,
      sym_comment,
    STATE(91), 1,
      sym_base_type,
    STATE(108), 1,
      sym_general_type,
    STATE(14), 2,
      sym_list_type,
      sym_tuple_type,
  [3843] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(225), 1,
      sym_identifier,
    ACTIONS(227), 1,
      anon_sym_LBRACK,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(237), 1,
      anon_sym_RPAREN,
    STATE(81), 1,
      sym_comment,
    STATE(91), 1,
      sym_base_type,
    STATE(103), 1,
      sym_general_type,
    STATE(14), 2,
      sym_list_type,
      sym_tuple_type,
  [3872] = 9,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(225), 1,
      sym_identifier,
    ACTIONS(227), 1,
      anon_sym_LBRACK,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    ACTIONS(239), 1,
      anon_sym_RPAREN,
    STATE(82), 1,
      sym_comment,
    STATE(91), 1,
      sym_base_type,
    STATE(108), 1,
      sym_general_type,
    STATE(14), 2,
      sym_list_type,
      sym_tuple_type,
  [3901] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(225), 1,
      sym_identifier,
    ACTIONS(227), 1,
      anon_sym_LBRACK,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    STATE(16), 1,
      sym_base_type,
    STATE(18), 1,
      sym_general_type,
    STATE(83), 1,
      sym_comment,
    STATE(14), 2,
      sym_list_type,
      sym_tuple_type,
  [3927] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(225), 1,
      sym_identifier,
    ACTIONS(227), 1,
      anon_sym_LBRACK,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    STATE(84), 1,
      sym_comment,
    STATE(91), 1,
      sym_base_type,
    STATE(108), 1,
      sym_general_type,
    STATE(14), 2,
      sym_list_type,
      sym_tuple_type,
  [3953] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(225), 1,
      sym_identifier,
    ACTIONS(227), 1,
      anon_sym_LBRACK,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    STATE(85), 1,
      sym_comment,
    STATE(91), 1,
      sym_base_type,
    STATE(129), 1,
      sym_general_type,
    STATE(14), 2,
      sym_list_type,
      sym_tuple_type,
  [3979] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(225), 1,
      sym_identifier,
    ACTIONS(227), 1,
      anon_sym_LBRACK,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    STATE(86), 1,
      sym_comment,
    STATE(91), 1,
      sym_base_type,
    STATE(119), 1,
      sym_general_type,
    STATE(14), 2,
      sym_list_type,
      sym_tuple_type,
  [4005] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(225), 1,
      sym_identifier,
    ACTIONS(227), 1,
      anon_sym_LBRACK,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    STATE(87), 1,
      sym_comment,
    STATE(113), 1,
      sym_base_type,
    STATE(14), 2,
      sym_list_type,
      sym_tuple_type,
  [4028] = 8,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(241), 1,
      anon_sym_COLON,
    ACTIONS(243), 1,
      anon_sym_EQ,
    ACTIONS(245), 1,
      anon_sym_LPAREN,
    ACTIONS(247), 1,
      anon_sym_LBRACE,
    STATE(88), 1,
      sym_comment,
    STATE(92), 1,
      sym_generics,
    STATE(145), 1,
      sym_named_arguments,
  [4053] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(225), 1,
      sym_identifier,
    ACTIONS(227), 1,
      anon_sym_LBRACK,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    STATE(89), 1,
      sym_comment,
    STATE(133), 1,
      sym_base_type,
    STATE(14), 2,
      sym_list_type,
      sym_tuple_type,
  [4076] = 7,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(225), 1,
      sym_identifier,
    ACTIONS(227), 1,
      anon_sym_LBRACK,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    STATE(90), 1,
      sym_comment,
    STATE(109), 1,
      sym_base_type,
    STATE(14), 2,
      sym_list_type,
      sym_tuple_type,
  [4099] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(229), 1,
      anon_sym_LPAREN,
    STATE(15), 1,
      sym_tuple_type,
    STATE(91), 1,
      sym_comment,
    ACTIONS(71), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [4117] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(245), 1,
      anon_sym_LPAREN,
    ACTIONS(249), 1,
      anon_sym_COLON,
    ACTIONS(251), 1,
      anon_sym_EQ,
    STATE(92), 1,
      sym_comment,
    STATE(151), 1,
      sym_named_arguments,
  [4136] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(253), 1,
      ts_builtin_sym_end,
    ACTIONS(255), 1,
      sym_identifier,
    STATE(123), 1,
      sym_definition,
    STATE(93), 2,
      sym_comment,
      aux_sym_source_file_repeat1,
  [4153] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(258), 1,
      anon_sym_COMMA,
    ACTIONS(261), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(94), 2,
      sym_comment,
      aux_sym_generics_repeat1,
  [4168] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(263), 1,
      anon_sym_COMMA,
    ACTIONS(101), 2,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(95), 2,
      sym_comment,
      aux_sym_full_list_repeat1,
  [4183] = 6,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(266), 1,
      ts_builtin_sym_end,
    STATE(93), 1,
      aux_sym_source_file_repeat1,
    STATE(96), 1,
      sym_comment,
    STATE(123), 1,
      sym_definition,
  [4202] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(268), 1,
      anon_sym_COMMA,
    ACTIONS(271), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(97), 2,
      sym_comment,
      aux_sym_tuple_type_repeat1,
  [4217] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(98), 1,
      sym_comment,
    ACTIONS(261), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [4229] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(173), 1,
      anon_sym_RBRACK,
    ACTIONS(273), 1,
      anon_sym_COMMA,
    STATE(95), 1,
      aux_sym_full_list_repeat1,
    STATE(99), 1,
      sym_comment,
  [4245] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(277), 1,
      anon_sym_RPAREN,
    STATE(100), 1,
      sym_comment,
    STATE(128), 1,
      sym_named_argument,
  [4261] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(279), 1,
      anon_sym_COMMA,
    ACTIONS(282), 1,
      anon_sym_RPAREN,
    STATE(101), 2,
      sym_comment,
      aux_sym_named_arguments_repeat1,
  [4275] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(102), 1,
      sym_comment,
    ACTIONS(284), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LPAREN,
  [4287] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(286), 1,
      anon_sym_COMMA,
    ACTIONS(288), 1,
      anon_sym_RPAREN,
    STATE(103), 1,
      sym_comment,
    STATE(110), 1,
      aux_sym_tuple_type_repeat1,
  [4303] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(290), 1,
      anon_sym_RPAREN,
    STATE(104), 1,
      sym_comment,
    STATE(128), 1,
      sym_named_argument,
  [4319] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(290), 1,
      anon_sym_RPAREN,
    ACTIONS(292), 1,
      anon_sym_COMMA,
    STATE(101), 1,
      aux_sym_named_arguments_repeat1,
    STATE(105), 1,
      sym_comment,
  [4335] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(106), 1,
      sym_comment,
    ACTIONS(294), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LPAREN,
  [4347] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(296), 1,
      anon_sym_COMMA,
    ACTIONS(298), 1,
      anon_sym_RBRACE,
    STATE(94), 1,
      aux_sym_generics_repeat1,
    STATE(107), 1,
      sym_comment,
  [4363] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(108), 1,
      sym_comment,
    ACTIONS(271), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [4375] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(245), 1,
      anon_sym_LPAREN,
    ACTIONS(300), 1,
      anon_sym_EQ,
    STATE(109), 1,
      sym_comment,
    STATE(140), 1,
      sym_named_arguments,
  [4391] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(233), 1,
      anon_sym_RPAREN,
    ACTIONS(302), 1,
      anon_sym_COMMA,
    STATE(97), 1,
      aux_sym_tuple_type_repeat1,
    STATE(110), 1,
      sym_comment,
  [4407] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(275), 1,
      sym_identifier,
    ACTIONS(304), 1,
      anon_sym_RPAREN,
    STATE(111), 1,
      sym_comment,
    STATE(114), 1,
      sym_named_argument,
  [4423] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(306), 1,
      sym_identifier,
    ACTIONS(308), 1,
      anon_sym_LPAREN,
    STATE(112), 1,
      sym_comment,
    STATE(150), 1,
      sym_tuple_of_identifiers,
  [4439] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(245), 1,
      anon_sym_LPAREN,
    ACTIONS(310), 1,
      anon_sym_EQ,
    STATE(113), 1,
      sym_comment,
    STATE(131), 1,
      sym_named_arguments,
  [4455] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(312), 1,
      anon_sym_COMMA,
    ACTIONS(314), 1,
      anon_sym_RPAREN,
    STATE(105), 1,
      aux_sym_named_arguments_repeat1,
    STATE(114), 1,
      sym_comment,
  [4471] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(316), 1,
      anon_sym_COMMA,
    ACTIONS(318), 1,
      anon_sym_RBRACE,
    STATE(107), 1,
      aux_sym_generics_repeat1,
    STATE(115), 1,
      sym_comment,
  [4487] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(320), 1,
      anon_sym_COMMA,
    ACTIONS(322), 1,
      anon_sym_RPAREN,
    STATE(116), 1,
      sym_comment,
    STATE(118), 1,
      aux_sym_generics_repeat1,
  [4503] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(117), 1,
      sym_comment,
    ACTIONS(324), 3,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LPAREN,
  [4515] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(326), 1,
      anon_sym_COMMA,
    ACTIONS(328), 1,
      anon_sym_RPAREN,
    STATE(94), 1,
      aux_sym_generics_repeat1,
    STATE(118), 1,
      sym_comment,
  [4531] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(330), 1,
      anon_sym_COMMA,
    ACTIONS(332), 1,
      anon_sym_RBRACE,
    STATE(119), 1,
      sym_comment,
    STATE(121), 1,
      aux_sym_tuple_type_repeat1,
  [4547] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(171), 1,
      anon_sym_RPAREN,
    ACTIONS(334), 1,
      anon_sym_COMMA,
    STATE(95), 1,
      aux_sym_full_list_repeat1,
    STATE(120), 1,
      sym_comment,
  [4563] = 5,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(235), 1,
      anon_sym_RBRACE,
    ACTIONS(336), 1,
      anon_sym_COMMA,
    STATE(97), 1,
      aux_sym_tuple_type_repeat1,
    STATE(121), 1,
      sym_comment,
  [4579] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(275), 1,
      sym_identifier,
    STATE(122), 1,
      sym_comment,
    STATE(128), 1,
      sym_named_argument,
  [4592] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(123), 1,
      sym_comment,
    ACTIONS(338), 2,
      ts_builtin_sym_end,
      sym_identifier,
  [4603] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(340), 1,
      sym_identifier,
    ACTIONS(342), 1,
      anon_sym_RBRACE,
    STATE(124), 1,
      sym_comment,
  [4616] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(328), 1,
      anon_sym_RPAREN,
    ACTIONS(340), 1,
      sym_identifier,
    STATE(125), 1,
      sym_comment,
  [4629] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(340), 1,
      sym_identifier,
    ACTIONS(344), 1,
      anon_sym_RPAREN,
    STATE(126), 1,
      sym_comment,
  [4642] = 4,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(298), 1,
      anon_sym_RBRACE,
    ACTIONS(340), 1,
      sym_identifier,
    STATE(127), 1,
      sym_comment,
  [4655] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(128), 1,
      sym_comment,
    ACTIONS(282), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [4666] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    STATE(129), 1,
      sym_comment,
    ACTIONS(346), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [4677] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(348), 1,
      anon_sym_EQ,
    STATE(130), 1,
      sym_comment,
  [4687] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(300), 1,
      anon_sym_EQ,
    STATE(131), 1,
      sym_comment,
  [4697] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(340), 1,
      sym_identifier,
    STATE(132), 1,
      sym_comment,
  [4707] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(350), 1,
      anon_sym_RBRACK,
    STATE(133), 1,
      sym_comment,
  [4717] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(352), 1,
      sym_identifier,
    STATE(134), 1,
      sym_comment,
  [4727] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(354), 1,
      anon_sym_of,
    STATE(135), 1,
      sym_comment,
  [4737] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(356), 1,
      anon_sym_COLON,
    STATE(136), 1,
      sym_comment,
  [4747] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(358), 1,
      anon_sym_LT_DASH,
    STATE(137), 1,
      sym_comment,
  [4757] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(360), 1,
      sym_identifier,
    STATE(138), 1,
      sym_comment,
  [4767] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(362), 1,
      anon_sym_EQ,
    STATE(139), 1,
      sym_comment,
  [4777] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(364), 1,
      anon_sym_EQ,
    STATE(140), 1,
      sym_comment,
  [4787] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(366), 1,
      anon_sym_RPAREN,
    STATE(141), 1,
      sym_comment,
  [4797] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(368), 1,
      anon_sym_EQ,
    STATE(142), 1,
      sym_comment,
  [4807] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(370), 1,
      sym_identifier,
    STATE(143), 1,
      sym_comment,
  [4817] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(372), 1,
      anon_sym_LT_DASH,
    STATE(144), 1,
      sym_comment,
  [4827] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(251), 1,
      anon_sym_EQ,
    STATE(145), 1,
      sym_comment,
  [4837] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(374), 1,
      anon_sym_EQ,
    STATE(146), 1,
      sym_comment,
  [4847] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(199), 1,
      anon_sym_then,
    STATE(147), 1,
      sym_comment,
  [4857] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(376), 1,
      anon_sym_LT_DASH,
    STATE(148), 1,
      sym_comment,
  [4867] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(378), 1,
      anon_sym_LT_DASH,
    STATE(149), 1,
      sym_comment,
  [4877] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(380), 1,
      anon_sym_LT_DASH,
    STATE(150), 1,
      sym_comment,
  [4887] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(310), 1,
      anon_sym_EQ,
    STATE(151), 1,
      sym_comment,
  [4897] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(382), 1,
      anon_sym_LT_DASH,
    STATE(152), 1,
      sym_comment,
  [4907] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(384), 1,
      ts_builtin_sym_end,
    STATE(153), 1,
      sym_comment,
  [4917] = 3,
    ACTIONS(3), 1,
      anon_sym_POUND,
    ACTIONS(386), 1,
      sym_identifier,
    STATE(154), 1,
      sym_comment,
  [4927] = 1,
    ACTIONS(388), 1,
      ts_builtin_sym_end,
  [4931] = 1,
    ACTIONS(390), 1,
      aux_sym_comment_token1,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 68,
  [SMALL_STATE(4)] = 136,
  [SMALL_STATE(5)] = 198,
  [SMALL_STATE(6)] = 250,
  [SMALL_STATE(7)] = 308,
  [SMALL_STATE(8)] = 362,
  [SMALL_STATE(9)] = 414,
  [SMALL_STATE(10)] = 453,
  [SMALL_STATE(11)] = 492,
  [SMALL_STATE(12)] = 531,
  [SMALL_STATE(13)] = 570,
  [SMALL_STATE(14)] = 609,
  [SMALL_STATE(15)] = 648,
  [SMALL_STATE(16)] = 686,
  [SMALL_STATE(17)] = 726,
  [SMALL_STATE(18)] = 766,
  [SMALL_STATE(19)] = 803,
  [SMALL_STATE(20)] = 840,
  [SMALL_STATE(21)] = 905,
  [SMALL_STATE(22)] = 942,
  [SMALL_STATE(23)] = 979,
  [SMALL_STATE(24)] = 1016,
  [SMALL_STATE(25)] = 1077,
  [SMALL_STATE(26)] = 1114,
  [SMALL_STATE(27)] = 1151,
  [SMALL_STATE(28)] = 1188,
  [SMALL_STATE(29)] = 1225,
  [SMALL_STATE(30)] = 1290,
  [SMALL_STATE(31)] = 1327,
  [SMALL_STATE(32)] = 1364,
  [SMALL_STATE(33)] = 1401,
  [SMALL_STATE(34)] = 1438,
  [SMALL_STATE(35)] = 1475,
  [SMALL_STATE(36)] = 1512,
  [SMALL_STATE(37)] = 1549,
  [SMALL_STATE(38)] = 1609,
  [SMALL_STATE(39)] = 1669,
  [SMALL_STATE(40)] = 1729,
  [SMALL_STATE(41)] = 1789,
  [SMALL_STATE(42)] = 1849,
  [SMALL_STATE(43)] = 1909,
  [SMALL_STATE(44)] = 1969,
  [SMALL_STATE(45)] = 2029,
  [SMALL_STATE(46)] = 2089,
  [SMALL_STATE(47)] = 2149,
  [SMALL_STATE(48)] = 2209,
  [SMALL_STATE(49)] = 2269,
  [SMALL_STATE(50)] = 2329,
  [SMALL_STATE(51)] = 2386,
  [SMALL_STATE(52)] = 2443,
  [SMALL_STATE(53)] = 2500,
  [SMALL_STATE(54)] = 2557,
  [SMALL_STATE(55)] = 2616,
  [SMALL_STATE(56)] = 2673,
  [SMALL_STATE(57)] = 2732,
  [SMALL_STATE(58)] = 2791,
  [SMALL_STATE(59)] = 2848,
  [SMALL_STATE(60)] = 2907,
  [SMALL_STATE(61)] = 2964,
  [SMALL_STATE(62)] = 3021,
  [SMALL_STATE(63)] = 3078,
  [SMALL_STATE(64)] = 3135,
  [SMALL_STATE(65)] = 3192,
  [SMALL_STATE(66)] = 3249,
  [SMALL_STATE(67)] = 3306,
  [SMALL_STATE(68)] = 3363,
  [SMALL_STATE(69)] = 3420,
  [SMALL_STATE(70)] = 3479,
  [SMALL_STATE(71)] = 3536,
  [SMALL_STATE(72)] = 3593,
  [SMALL_STATE(73)] = 3629,
  [SMALL_STATE(74)] = 3664,
  [SMALL_STATE(75)] = 3687,
  [SMALL_STATE(76)] = 3710,
  [SMALL_STATE(77)] = 3733,
  [SMALL_STATE(78)] = 3756,
  [SMALL_STATE(79)] = 3785,
  [SMALL_STATE(80)] = 3814,
  [SMALL_STATE(81)] = 3843,
  [SMALL_STATE(82)] = 3872,
  [SMALL_STATE(83)] = 3901,
  [SMALL_STATE(84)] = 3927,
  [SMALL_STATE(85)] = 3953,
  [SMALL_STATE(86)] = 3979,
  [SMALL_STATE(87)] = 4005,
  [SMALL_STATE(88)] = 4028,
  [SMALL_STATE(89)] = 4053,
  [SMALL_STATE(90)] = 4076,
  [SMALL_STATE(91)] = 4099,
  [SMALL_STATE(92)] = 4117,
  [SMALL_STATE(93)] = 4136,
  [SMALL_STATE(94)] = 4153,
  [SMALL_STATE(95)] = 4168,
  [SMALL_STATE(96)] = 4183,
  [SMALL_STATE(97)] = 4202,
  [SMALL_STATE(98)] = 4217,
  [SMALL_STATE(99)] = 4229,
  [SMALL_STATE(100)] = 4245,
  [SMALL_STATE(101)] = 4261,
  [SMALL_STATE(102)] = 4275,
  [SMALL_STATE(103)] = 4287,
  [SMALL_STATE(104)] = 4303,
  [SMALL_STATE(105)] = 4319,
  [SMALL_STATE(106)] = 4335,
  [SMALL_STATE(107)] = 4347,
  [SMALL_STATE(108)] = 4363,
  [SMALL_STATE(109)] = 4375,
  [SMALL_STATE(110)] = 4391,
  [SMALL_STATE(111)] = 4407,
  [SMALL_STATE(112)] = 4423,
  [SMALL_STATE(113)] = 4439,
  [SMALL_STATE(114)] = 4455,
  [SMALL_STATE(115)] = 4471,
  [SMALL_STATE(116)] = 4487,
  [SMALL_STATE(117)] = 4503,
  [SMALL_STATE(118)] = 4515,
  [SMALL_STATE(119)] = 4531,
  [SMALL_STATE(120)] = 4547,
  [SMALL_STATE(121)] = 4563,
  [SMALL_STATE(122)] = 4579,
  [SMALL_STATE(123)] = 4592,
  [SMALL_STATE(124)] = 4603,
  [SMALL_STATE(125)] = 4616,
  [SMALL_STATE(126)] = 4629,
  [SMALL_STATE(127)] = 4642,
  [SMALL_STATE(128)] = 4655,
  [SMALL_STATE(129)] = 4666,
  [SMALL_STATE(130)] = 4677,
  [SMALL_STATE(131)] = 4687,
  [SMALL_STATE(132)] = 4697,
  [SMALL_STATE(133)] = 4707,
  [SMALL_STATE(134)] = 4717,
  [SMALL_STATE(135)] = 4727,
  [SMALL_STATE(136)] = 4737,
  [SMALL_STATE(137)] = 4747,
  [SMALL_STATE(138)] = 4757,
  [SMALL_STATE(139)] = 4767,
  [SMALL_STATE(140)] = 4777,
  [SMALL_STATE(141)] = 4787,
  [SMALL_STATE(142)] = 4797,
  [SMALL_STATE(143)] = 4807,
  [SMALL_STATE(144)] = 4817,
  [SMALL_STATE(145)] = 4827,
  [SMALL_STATE(146)] = 4837,
  [SMALL_STATE(147)] = 4847,
  [SMALL_STATE(148)] = 4857,
  [SMALL_STATE(149)] = 4867,
  [SMALL_STATE(150)] = 4877,
  [SMALL_STATE(151)] = 4887,
  [SMALL_STATE(152)] = 4897,
  [SMALL_STATE(153)] = 4907,
  [SMALL_STATE(154)] = 4917,
  [SMALL_STATE(155)] = 4927,
  [SMALL_STATE(156)] = 4931,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [9] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let, 6),
  [11] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let, 6),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [31] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 6),
  [33] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 6),
  [35] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 3),
  [37] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 3),
  [39] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefix, 2),
  [41] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefix, 2),
  [43] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 2),
  [45] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 2),
  [47] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 5),
  [49] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 5),
  [51] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4),
  [53] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4),
  [55] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3),
  [57] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3),
  [59] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_type, 3),
  [61] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_type, 3),
  [63] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_type, 1),
  [65] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_base_type, 1),
  [67] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_general_type, 2),
  [69] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_general_type, 2),
  [71] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_general_type, 1),
  [73] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_general_type, 1),
  [75] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple, 1),
  [77] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_simple, 1),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [81] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_list, 4),
  [83] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_list, 4),
  [85] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_list, 4),
  [87] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_full_list, 4),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [93] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_resolution, 6),
  [95] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_resolution, 6),
  [97] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bool, 1),
  [99] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bool, 1),
  [101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_full_list_repeat1, 2),
  [103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 2),
  [105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 2),
  [107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 4),
  [109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 4),
  [111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1),
  [113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1),
  [115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 1),
  [117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 1),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_resolution, 4),
  [125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_resolution, 4),
  [127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_list, 5),
  [129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_full_list, 5),
  [131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 5),
  [133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 5),
  [135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 3),
  [137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 3),
  [139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_list, 3),
  [141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_full_list, 3),
  [143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_resolution, 5),
  [145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_resolution, 5),
  [147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2),
  [149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_definition, 3),
  [177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_definition, 5),
  [179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_definition, 7),
  [181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_definition, 6),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_definition, 4),
  [195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_unpack, 7),
  [197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_unpack, 5),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mult_div, 1),
  [211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mult_div, 1),
  [213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical, 1),
  [215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical, 1),
  [217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comparator, 1),
  [219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comparator, 1),
  [221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_add_sub, 1),
  [223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_add_sub, 1),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(88),
  [258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generics_repeat1, 2), SHIFT_REPEAT(132),
  [261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generics_repeat1, 2),
  [263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_full_list_repeat1, 2), SHIFT_REPEAT(63),
  [266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [268] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2), SHIFT_REPEAT(84),
  [271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_arguments_repeat1, 2), SHIFT_REPEAT(122),
  [282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_arguments_repeat1, 2),
  [284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generics, 4),
  [286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generics, 3),
  [296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generics, 5),
  [326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1),
  [340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_argument, 3),
  [348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_arguments, 4),
  [350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_arguments, 2),
  [364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_arguments, 5),
  [370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_of_identifiers, 4),
  [374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_arguments, 3),
  [376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_of_identifiers, 3),
  [378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_of_identifiers, 5),
  [384] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 2),
  [390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_azor(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .public_symbol_map = ts_symbol_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
